package de.ivu.elect.business.system.control.status;

import java.util.Collections;
import java.util.List;

import javax.inject.Inject;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.mandant.entity.Mandant;
import de.ivu.elect.business.system.control.WildFlyServer;
import de.ivu.elect.business.system.entity.SystemStatusOptionGroup;
import de.ivu.elect.jee.presentation.status.StatusEntry;
import de.ivu.elect.jee.presentation.status.StatusOptionType;

/**
 *  on 26.05.2017.
 */
public class WildFlyHttpsHttp2PushSystemStatusOptionResolver extends AbstractSystemStatusOptionResolver {

  private static final Logger LOG = LoggerFactory.getLogger(WildFlyHttpsHttp2PushSystemStatusOptionResolver.class);

  private static final StatusOptionType WILDFLY_HTTPS_HTTP2_PUSH_PARAMETERS = new StatusOptionType() {
  };

  @Inject
  private transient WildFlyServer wildFlyServer;

  @Override
  protected StatusEntry resolveSystemStatusOption(SystemStatusOption systemStatusOption) {

    boolean httpsHttp2Enabled = wildFlyServer.isHttpsHttp2Enabled();
    boolean httpsHttp2PushEnabled = wildFlyServer.isHttpsHttp2PushEnabled();

    LOG.info("httpsHttp2Enabled="+httpsHttp2Enabled+", httpsHttp2PushEnabled="+httpsHttp2PushEnabled);

    if (!httpsHttp2Enabled || !httpsHttp2PushEnabled) {
      return ok("system.info.konfiguriert.https.http2.push.ok");
    }
    return error/*Error, weil 'denial of service' droht, wenn aktiviert*/("system.info.konfiguriert.https.http2.push.nok");
  }

  @Override
  protected boolean isAccept(Mandant mandant) {
    return mandant.getArt().isSystemMandant();
  }

  @Override
  protected List<SystemStatusOption> getStatusOptionsInternal(Mandant mandant) {
    return Collections.singletonList(new SystemStatusOption(WILDFLY_HTTPS_HTTP2_PUSH_PARAMETERS, mandant));
  }

  @Override
  public SystemStatusOptionGroup getSystemStatusOptionGroup() {
    return SystemStatusOptionGroup.APPSERVER_KONFIGURATION;
  }

}
